
//-----------------------------------------------------------------------------
// sortTable(id, col, rev, typ, df)
// version 0.6

//  id  - identyfikator kontenera do posortowania
//  col - indeks kolumny wg ktorej przebiega sortowanie, numerowane od zera
//  tryb - tryb numerowania pierwszej kolumny: N- none, R- ranking, L- lp.
//  typ - "D"- data, pozostae s nieistotne w tej wersji
//  df - opcjonalnie format daty, w postaci takiej jak w date.js 

function sortTable(id, col, tryb,rev,typ,df,colored) {

var dFormat='d-M-y';


if(typ=="D") {

if(df) dFormat=df;

}
 
  var tblEl = document.getElementById(id);


  if (tblEl.reverseSort == null) {
    tblEl.reverseSort = new Array();
    tblEl.lastColumn = 0;
  }

  if (tblEl.reverseSort[col] == null)
    tblEl.reverseSort[col] = rev;

  if (col == tblEl.lastColumn)
    tblEl.reverseSort[col] = !tblEl.reverseSort[col];

  
  tblEl.lastColumn = col;

  // sztuczka dla Netscape 6
  var oldDsply = tblEl.style.display;
  tblEl.style.display = "none";

  // --- sortowanie


  var i;

  //dwie tablice; jedna tablica zawiera tylko pole wg ktrego jest sortowanie
  //i indeks tablicy, druga zawiera rzeczywiste wiersze z tabeli

  var srt = new Array(tblEl.rows.length);
  var temp = new Array(tblEl.rows.length);
  var loBound = null;
  var hiBound = null;
  var len = tblEl.rows.length;

  for (i = 0; i < len; i++) {
 	val = getTextValue(tblEl.rows[0].cells[col]);
 	if(typ=="D") {
 	 srt[i]=new Array(getDateFromFormat(val,df),i);
 	} else if(typ!="T"){
 	 srt[i]=new Array(toNumberValue(val),i);
 	} else {
	 srt[i] = new Array(val,i);
	}
	temp[i] = tblEl.removeChild(tblEl.rows[0]);
  }


  //posortuj

   quicksort(srt,0,len-1,typ);


  //utwrz tabelk z posortowanych wierszy (uwaga: sortowanie tak naprawd
  //jest zawsze w jedn stron)
  if(tblEl.reverseSort[col]) {
   for (i=len-1; i>=0; i--) {
  
        tblEl.appendChild(temp[srt[i][1]]);
    }

  } else {
    for (i=0; i<len; i++) {
  
        tblEl.appendChild(temp[srt[i][1]]);
    }
 }

  //przypisz style
  makePretty(tblEl, col,colored);

if(tryb=="R"){
  setRanks(tblEl, col);
}
if(tryb=="L"){
  setNumeration(tblEl,col);
}
  // Przywrc wygld
  tblEl.style.display = oldDsply;

  return false;
}

// Poprawka dla nIEktrych browserw
if (document.ELEMENT_NODE == null) {
  document.ELEMENT_NODE = 1;
  document.TEXT_NODE = 3;
}

// pobiera i konkatenuje wszystkie potomne elementy tekstowe
function getTextValue(el) {

  var i;
  var s;

  s = "";
  for (i = 0; i < el.childNodes.length; i++)
    if (el.childNodes[i].nodeType == document.TEXT_NODE)
      s += el.childNodes[i].nodeValue;
    else if (el.childNodes[i].nodeType == document.ELEMENT_NODE &&
             el.childNodes[i].tagName == "BR")
      s += " ";
    else

      s += getTextValue(el.childNodes[i]);

  return normalizeString(s);
}

function toNumberValue(val) {

var whtSpMult = new RegExp("\\s", "g");
var commaMult = new RegExp(",","g");

var f;

f = val.replace(whtSpMult,"");
f = f.replace(commaMult,".");

return f;
}

//porwnuje dwie wartoci (float, int, string)
//by moe trzeba bdzie to rozpisa na wicej funkcji (inna dla
//kadego typu), bdzie szybciej?
function comp(v1, v2,typ) {

  var f1, f2;

  // probuje konwersji na floaty



if((typ=="C")||(typ=="F")){

  f1 = parseFloat(v1);
  f2 = parseFloat(v2);
  if (!isNaN(f1) && !isNaN(f2)) {
    v1 = f1;
    v2 = f2;
  }
 }

if(typ=="I"){
  // a teraz na inty
  f1 = parseInt(v1);
  f2 = parseInt(v2);
  if (!isNaN(f1) && !isNaN(f2)) {
    v1 = f1;
    v2 = f2;
  }
}

  if (v1 == v2)
    return 0;
  if (v1 > v2)
    return 1
  return -1;
}



// regexpy do wyrzucenia whitespacw
var whtSpEnds = new RegExp("^\\s*|\\s*$", "g");
var whtSpMult = new RegExp("\\s\\s+", "g");

function normalizeString(s) {

  s = s.replace(whtSpMult, " ");
  s = s.replace(whtSpEnds, ""); 

  return s;
}

// nazwy stylw dla wierszy i kolumn- nie jestem pewien czy nie
// powinno by to sparametryzowane- ale moe nie.

var rowClsNm = "alternateRow";
var rowClsAl = "normalRow";
var colClsNm = "sortedColumn";


var rowTest = new RegExp(rowClsNm, "gi");
var rowTestA = new RegExp(rowClsAl, "gi");
var colTest = new RegExp(colClsNm, "gi");

function makePretty(tblEl, col,colored) {

  var i, j;
  var rowEl, cellEl;

  if(colored){
	  for (i = 0; i < tblEl.rows.length; i++) {
	  
	 //koloruje wiersze
	   rowEl = tblEl.rows[i];
	
	   rowEl.className = rowEl.className.replace(rowTest, "");
	   rowEl.className = rowEl.className.replace(rowTestA, "");
	       if (i % 2 != 0)
	      		rowEl.className += " " + rowClsNm;
			else 
				rowEl.className += " " + rowClsAl;
	    rowEl.className = normalizeString(rowEl.className);
	   
	    // podwietla posortowan kolumn
	    for (j = 0; j < tblEl.rows[i].cells.length; j++) {
	      cellEl = rowEl.cells[j];
	      cellEl.className = cellEl.className.replace(colTest, "");
	      
	      if (j == col)
	        cellEl.className += " " + colClsNm;
	        cellEl.className = normalizeString(cellEl.className);
	  }
    }
  }
  // podwietla header sortowanej kolumny
  var el = tblEl.parentNode.tHead;

  rowEl = el.rows[el.rows.length - 1];

  for (i = 0; i < rowEl.cells.length; i++) {
    cellEl = rowEl.cells[i];
    cellEl.className = cellEl.className.replace(colTest, "");

    if (i == col)
      cellEl.className += " " + colClsNm;
      cellEl.className = normalizeString(cellEl.className);
  }
}

//tryb rankingowy
function setRanks(tblEl, col) {

  var i    = 0;
  var incr = 1;
  rev=false;
  if (tblEl.reverseSort[col])
    rev = !rev;
  if (rev) {
    incr = -1;
    i = tblEl.rows.length - 1;
  }

  var count   = 1;
  var rank    = count;
  var curVal;
  var lastVal = null;


  while (i >= 0 && i < tblEl.rows.length) {


    curVal = getTextValue(tblEl.rows[i].cells[col]);

    if (lastVal != null && compareValues(curVal, lastVal) != 0)
        rank = count;
    tblEl.rows[i].rank = rank;

    lastVal = curVal;
    count++;
    i += incr;
  }


  var rowEl, cellEl;
  var lastRank = 0;


  for (i = 0; i < tblEl.rows.length; i++) {
    rowEl = tblEl.rows[i];
    cellEl = rowEl.cells[0];

    while (cellEl.lastChild != null)
      cellEl.removeChild(cellEl.lastChild);


      cellEl.appendChild(document.createTextNode(rowEl.rank));
      lastRank = rowEl.rank;

  }
}

//ustalona numeracja
function setNumeration(tblEl, col) {

  var rowEl, cellEl;


  for (i = 0; i < tblEl.rows.length; i++) {
    rowEl = tblEl.rows[i];
    cellEl = rowEl.cells[0];

    while (cellEl.lastChild != null)
      cellEl.removeChild(cellEl.lastChild);

      cellEl.appendChild(document.createTextNode(i+1));
  }
}




function quicksort(vec, loBound, hiBound,typ){


		var pivot, loSwap, hiSwap, temp;

		if (hiBound - loBound == 1)
		{
			if (comp(vec[loBound][0], vec[hiBound][0],typ)>0)
			{
				temp = vec[loBound];
				vec[loBound] = vec[hiBound];
				vec[hiBound] = temp;
			}
			return;
		}

		pivot = vec[parseInt((loBound + hiBound) / 2)];
		vec[parseInt((loBound + hiBound) / 2)] = vec[loBound];
		vec[loBound] = pivot;
		loSwap = loBound + 1;
		hiSwap = hiBound;
		do {
			while (loSwap <= hiSwap && (comp(vec[loSwap][0], pivot[0],typ)<=0))
				loSwap++;

			while (comp(vec[hiSwap][0], pivot[0],typ)>0)
				hiSwap--;

			if (loSwap < hiSwap)
			{
				temp = vec[loSwap];
				vec[loSwap] = vec[hiSwap];
				vec[hiSwap] = temp;
			}
		} while (loSwap < hiSwap);

		vec[loBound] = vec[hiSwap];
		vec[hiSwap] = pivot;

		if (loBound < hiSwap - 1)
			quicksort(vec, loBound, hiSwap - 1,typ);

		if (hiSwap + 1 < hiBound)
			quicksort(vec, hiSwap + 1, hiBound,typ);
	}
	
var selectedRow = null;
var remSelected = new RegExp("highRow","g");


/**
	This function highlights a row.
	Second click causes another function to be executed.
*/
function highlight(event, param) {

	// get table row from elem clicked	
		
	 var btn;
	
	//this isn't really very elegant, but needed since Explorer sucks as usual
	  if (window.event)
	    btn = window.event.srcElement;
	  else
	    btn = event.currentTarget;
	
	var node = btn.parentNode; 
	
	  while (node != null) {
	  	if (node.tagName != null && node.tagName == 'TR') break;
		node = node.parentNode;
	}
	
	//here, we should have the row responsible
	
	if(node==selectedRow) {
	
	//this function must be defined somewhere else- not elegant, but effective
	
		highClicked(param);
	} else {

	
		//first, clear the className from previously selected row
		
		if(selectedRow) {
			selectedRow.className = selectedRow.className.replace(remSelected,"");
		}
		
		//now, put the className to selected row
		
		node.className += " highRow";
		selectedRow = node;
	}
	return false;
	}	

